#include "defines.h"
#include "includes.h"
#include "funcs.h"

void aumixer()
{
/*  aumix: invalid option -- ? */
/*  aumix 2.6 usage: aumix [-<channel option>[[+|-][<amount>]]|<level>| */
/*  R[ecord]|P[lay]|q[uery]] [-dhILqS] [-f <rc file>][-C <color scheme file>] */
/*   */
/*  channel options: */
/*    v:  main volume           x:  mix monitor */
/*    b:  bass                  W:  PCM 2 */
/*    t:  treble                r:  record */
/*    s:  synthesizer           i:  input gain */
/*    w:  PCM                   o:  output gain */
/*    p:  PC speaker            1:  line 1 */
/*    l:  line                  2:  line 2 */
/*    m:  microphone            3:  line 3 */
/*    c:  CD */
/*   */
/*  other options: */
/*    d:  adjust a device besides /dev/mixer */
/*    f:  specify file for saving and loading settings (defaults to */
/*        ~/.aumixrc or /etc/aumixrc) */
/*    C:  specify color scheme */
/*    h:  this helpful message */
/*    I:  start in interactive mode after doing non-interactive functions */
/*    L:  load settings */
/*    q:  query all channels and print their settings */
/*    S:  save settings */
/*  vol 85, 85 */
/*  bass 100, 100 */
/*  treble 100, 100 */
/*  synth 100, 100 */
/*  pcm 100, 100 */
/*  speaker 100, 100 */
/*  line 100, 100 */
/*  mic 0, 0, R */
/*  cd 100, 100  */
/*  mix 100, 100 */
/*  igain 0, 0 */
/*  line1 0, 0, P */
/*  line2 0, 0 */
/*  line3 0, 0, P */

	mixcontrol=calloc(1,128);
	mixstart=mixcontrol;
	tmppipe=popen("aumix -q","r");
	for (;fgets(junk,128,tmppipe)!=NULL;)
	{
			if (strstr(junk,"vol ")!=NULL) strcat(mixcontrol,"v");
			if (strstr(junk,"bass ")!=NULL) strcat(mixcontrol,"b");
			if (strstr(junk,"treble ")!=NULL) strcat(mixcontrol,"t");
			if (strstr(junk,"synth ")!=NULL) strcat(mixcontrol,"s");
			if (strstr(junk,"pcm ")!=NULL) strcat(mixcontrol,"w");
			if (strstr(junk,"pcm2 ")!=NULL) strcat(mixcontrol,"W");
			if (strstr(junk,"speaker ")!=NULL) strcat(mixcontrol,"p");
			if (strstr(junk,"line ")!=NULL) strcat(mixcontrol,"l");
			if (strstr(junk,"mic ")!=NULL) strcat(mixcontrol,"m");
			if (strstr(junk,"cd ")!=NULL) strcat(mixcontrol,"c");
			if (strstr(junk,"mix ")!=NULL) strcat(mixcontrol,"x");
			if (strstr(junk,"igain ")!=NULL) strcat(mixcontrol,"i");
			if (strstr(junk,"ogain ")!=NULL) strcat(mixcontrol,"o");
			if (strstr(junk,"record ")!=NULL) strcat(mixcontrol,"r");
			if (strstr(junk,"line1 ")!=NULL) strcat(mixcontrol,"1");
			if (strstr(junk,"line2 ")!=NULL) strcat(mixcontrol,"2");
			if (strstr(junk,"line3 ")!=NULL) strcat(mixcontrol,"3");
	}
	if ((int)tmppipe>2) pclose(tmppipe);

	/* if there are no controls, set the string to null */
	if (strlen(mixcontrol)==0)
	{
		free(mixcontrol);
		mixcontrol=NULL;
		mixstart=NULL;
	}
}

char *aumixstat(char *in)
{
	if (strncmp(mixcontrol,"v",1)==0) return("Volume");
	if (strncmp(mixcontrol,"b",1)==0) return("Bass");
	if (strncmp(mixcontrol,"t",1)==0) return("Treble");
	if (strncmp(mixcontrol,"s",1)==0) return("Synth");
	if (strncmp(mixcontrol,"w",1)==0) return("PCM");
	if (strncmp(mixcontrol,"W",1)==0) return("PCM2");
	if (strncmp(mixcontrol,"p",1)==0) return("Speaker");
	if (strncmp(mixcontrol,"l",1)==0) return("Line");
	if (strncmp(mixcontrol,"m",1)==0) return("Microphone");
	if (strncmp(mixcontrol,"c",1)==0) return("CD");
	if (strncmp(mixcontrol,"x",1)==0) return("Mixer");
	if (strncmp(mixcontrol,"i",1)==0) return("Input Gain");
	if (strncmp(mixcontrol,"o",1)==0) return("Output Gain");
	if (strncmp(mixcontrol,"r",1)==0) return("Record");
	if (strncmp(mixcontrol,"1",1)==0) return("Line 1");
	if (strncmp(mixcontrol,"2",1)==0) return("Line 2");
	if (strncmp(mixcontrol,"3",1)==0) return("Line 3");
	return (NULL);
}
