/*
Vorbis song info, made by Guillaume Cottenceau.
*/

#include "includes.h"
#include "funcs.h"
#include "defines.h"

#define _REENTRANT 1
#include <stdio.h>
#include <fcntl.h>
#include <stdlib.h>
#include <string.h>
#include <pthread.h>
#include <vorbis/vorbisfile.h>
#include <vorbis/codec.h>

#define BLOCK_SIZE 4096

int ogghed(char *dir, char *argy)
{
  char *filename;
  FILE *stream;
  OggVorbis_File vf;
  int length=0;
  int minutes=0;
  int seconds=0;
  
	filename=calloc(1,255);

	strcat(filename,dir);
	strcat(filename,"/");
	strcat(filename,argy);
	
  
  if((stream = fopen(filename, "r")) == NULL)
    {
      printf("E: could not open %s\n", filename);
      return(1);
    }
  
  /* The open function performs full stream detection and machine
     initialization.  If it returns zero, the stream *is* Vorbis and
     we're fully ready to decode. */
  if(ov_open(stream, &vf, NULL, 0) < 0)
    {
      printf("E: not a Vorbis stream\n");
      fclose(stream);
      return(1);
    }
  
  /* Retrieve the length */
  length = ov_time_total(&vf, -1) * 1000;
  
/*  printf("total-length %d\n", length); */

  minutes = (length/1000)/60;
  seconds = ((length/1000) - minutes*60);
  /* printf("length-in-minutes-and-seconds %d %d\n", minutes, seconds);

  sleep(5); */
  
  ov_clear(&vf); /* once the ov_open succeeds, the stream belongs to
                     vorbisfile.a.  ov_clear will fclose it */
  return((minutes * 60)+seconds);
}

